import pitaru.sonia_v2_9.*;
import Phidgets.*;
import Phidgets.Events.*;

public class TinyTony extends PApplet{



PhidgetServo phid;

float x,y;
int minFreq = 4000;
int maxFreq = 0;
float fak = 1.5;
PImage bg;
PFont font;
Sample mySample;
float sampleRate;


// Phidget-Steuerung
  float leftFreq = 100;
  float rightFreq = 740;
  
  float minPosH = 25;
  float maxPosH = 210;

  float minLevelV = .1;
  float maxLevelV = .6;
  
  float minPosV = 38;
  float maxPosV = 133;

static public void main(String args[]){
  PApplet.main(new String[] {"--display=1","--present","TinyTony"}); 
  
}

void setup(){  
   
   framerate(20);
   size(1280,854);
   smooth();
   
   phid = new PhidgetServo();	
   println("PhidgetServo "+phid.OpenRemoteIP("localhost",5001,11033,"pass"));
  
   Sonia.start(this); // Start Sonia engine.
   LiveInput.start(4096); 
   
   // Draw Screen
   font = loadFont("ArialNarrow-20.vlw");
   textFont(font, 12); 
   background(255);
   bg = loadImage("TinyTony_Interface_01.gif");
   image(bg,0,0);
   
   mySample = new Sample("TinyToni.aif");
   mySample.repeat();
   mySample.setVolume(.8);
}


void draw(){
   framerate(25);
 
// clear Background
   fill(255);
   rect(0,324,width,height-324);

// scales
   drawScales();
   
// show Spectrum
   float level = getMeterLevel(); // Show meter-level reading for Left/Right channels.
   int pos = getSpectrum();
   
   // min Max messen
   if (level > .5){ 
     if (pos < minFreq) minFreq = pos;
     if (pos > maxFreq) maxFreq = pos;
     //println(minFreq + " " + maxFreq);
   }
   //println(framerate + " " + pos); // Show FFT reading
   x += (pos-x)/3;
   y += (level-y)/10;
   
// Cross
   stroke(200,200,250);
   line (x*fak,330,x*fak,height);
   float y = max(330,height-level*1000);
   line (0,y,width,y);  
   
// Set Motor-Position  
   //if (phid.GetIsAttached() && level > .1) {	
     
     // Horiz
     float p =  minPosH + ( pos - leftFreq )/( rightFreq - leftFreq ) * ( maxPosH - minPosH );
     phid.SetMotorPosition(0,p);
     //println("H "+p);
     
     // Vertical
     p =  minPosV + abs( level - minLevelV )/( maxLevelV - minLevelV ) * ( maxPosV - minPosV );
     phid.SetMotorPosition(1,p);
     println(level+" V "+p);
     
   //}
   
}

void drawScales() {
   stroke(200);
   int y = 324;
   for ( int i = 0; i < width; i+=5){     
     if (i%20 == 0) line(i,y,i,y+10);
     else line(i,y,i,y+5);
   }
   
   for ( int i = y; i < height; i+=5){     
     if ((i-y)%20 == 0) line(width-10,i,width,i);
     else line(width-5,i,width,i);
   }
   fill(200);
   text("FREQUENZSPEKTRUM DER UMGEBUNGSGERUSCHE", 97,370);
   //text("[ Frequenzspektrum der Umgebungsgerusche ]", 105,360);
   
}

int getSpectrum(){
  // populate the spectrum array with FFT values.
   LiveInput.getSpectrum(true, 1);
   // draw a bar for each of the elements in the spectrum array.
   // Note - the current FFT math is done in Java and is very raw. expect optimized alternative soon.
   
   float max = 0;
   int freq = 0;
   stroke(150);
   for ( int i = 0; i < width; i++){
     //if (i%2==0) stroke(150);
     //else stroke(120);
     if (LiveInput.spectrum[i] > 1) {
       float y = max(330,height - LiveInput.spectrum[i]/35-2);
       line(i*fak, height, i*fak, y);
     }
     if (LiveInput.spectrum[i] > max){
       max = LiveInput.spectrum[i];
       freq = i;
     }
   }
   
   return freq;
}


float getMeterLevel(){
   // get Peak level for each channel (0 -> Left , 1 -> Right)
   // Value Range: float from 0.0 to 1.0
   // Note: use inputMeter.getLevel() to combine both channels (L+R) into one value.
   float meterDataLeft = LiveInput.getLevel();
   float meterDataRight = LiveInput.getLevel();

  //println(meterDataLeft*10+" "+meterDataRight*10);

   // draw a volume-meter for each channel.
   noStroke();
   fill(0,100,0,30);
   float left = meterDataLeft*height*2;
   float right = meterDataRight*height*2; 
   //rect(width/2 - 10, height, 10 , left*-1);
   //rect(width/2 , height, 10, right*-1);
   
   return (meterDataLeft+meterDataRight)/2;
}

}

/*
// Safely close the sound engine upon Browser shutdown.
public void stop(){
    Sonia.stop();
    //super.stop();
}*/
